*============================================================================
* gbsgriddy:  Griddy sampling for a single parameter
* Author: John Thompson
* Date:   Dec 2012
*============================================================================
program gbsgriddy, rclass
   version 12.1
   syntax anything [fweight pweight aweight iweight] [if] [in] ,  ///
   Grid(numlist ascending min = 4) ///
   [                               ///
   Metropolis                      ///
   Histogram                       ///
   LOGP(real 1e20)                 ///
   ]
   marksample touse
   
   tokenize "`anything'"
   local logfunct "`1'"
   local b "`2'"
   local ipar "`3'"
   if "`weight'" != "" local wt "[`weight'`exp']"
   
   if `logp' > 1e19    local logp = "."
   tempname slp
   
   if "`metropolis'" != "" local m = 1
   else local m = 0
   if "`histogram'" != "" local h = 1
   else local h = 0
   mata: gbsgriddy_stata("`logfunct' `slp' `b' `ipar' `wt' if `touse'","`slp'",`logp',"`b'",`ipar',"`grid'",`m',`h')
   return scalar logp = `logp'
end
