{smcl}
{* *! version 1.0.0 dec2012}{...}
{cmd:help gbsgriddy} 
{hline}

{title:Title}

{p2colset 5 18 20 2}{...}
{p2col :{hi:gbsgriddy} {hline 2}}Griddy sampler for use in Gibbs sampling{p_end}
{p2colreset}{...}


{title:Syntax}

{phang2}
{cmd:gbsgriddy} {it:logpost rowvector parameter}
{ifin}
{weight}{cmd:,}
{opth g:rid(numlist)}
[{it:options}]

{phang}
{it:logpost} must be the name of the user's program for calculating the log of
the conditional posterior density.
See {help mhsnorm##userprog:Structure for the user's program} in
{helpb mhsnorm} for more details on how to write the program for the log
posterior.

{phang}
{it:rowvector} must be the name of the row vector containing the parameter
values.

{phang}
{it:parameter} must be the number of the parameter that is being updated.

{synoptset 16 tabbed}{...}
{synopthdr}
{synoptline}
{p2coldent:* {opth g:rid(numlist)}}initial grid of points{p_end}
{synopt:{opt h:istogram}}histogram approximation to the density{p_end}
{synopt:{opt m:etropolis}}add Metropolis step{p_end}
{synopt:{opt logp(#)}}log posterior at the current point{p_end}
{synoptline}
{p2colreset}{...}
{p 4 6 2}
* {cmd:grid()} is required.{p_end}
{p 4 6 2}
{opt fweight}s, {opt aweight}s, {opt iweight}s, and {opt pweight}s are
allowed; see {help weight}.


{title:Description}

{pstd}
{cmd:gbsgriddy} uses Griddy sampling to simulate a value from a
one-dimensional posterior distribution. It is useful in Gibbs sampling. Griddy
sampling works by approximating the posterior by either a histogram or a set
of straight lines drawn through a grid of points.  By default, a straight-line
approximation is used. The grid must consist of at least 4 ascending values
specified by the user. Placement of the grid is vital to the success of the
algorithm, so it is only useful if the user knows roughly where the posterior
will lie. The {cmd:metropolis} option compares the generated value with the
previous value by a Metropolis step. This makes the approximation exact within
the range of the grid. If a Metropolis step is used, then the grid must not be
placed using information derived from the same chain. For speed, the
algorithm is programmed in Mata, although the user's program for evaluating
the log posterior may be written in Stata or Mata.  The Mata code is stored
in the library {cmd:libmcmc}, which must be installed for the command to work.


{title:Options}

{phang}
{opth grid(numlist)} specifies a set of points defining the initial grid for
the envelope that approximates the log posterior.  The grid must contain at
least 4 points. {cmd:grid()} is required.{p_end}

{phang}
{opt histogram} specifies a histogram approximation to the density rather than
a straight-line approximation.{p_end}

{phang}
{opt metropolis} specifies the exact posterior within the range of the grid by
treating the approximation as a proposal distribution and using a Metropolis
step to accept or reject the generated value.  By default, an approximation to
the posterior is used.

{phang}
{opt logp(#)} specifies the log posterior for the current set of parameter
values. {cmd:logp()} is only useful if {cmd:metropolis} is also specified. If
{cmd:logp()} is set to missing, this value is calculated by the program.{p_end}


{title:Stored results}

{pstd}
{cmd:gbsgriddy} stores the following in {cmd:r()}:

{synoptset 12 tabbed}{...}
{p2col 5 12 16 2: Scalars}{p_end}
{synopt:{cmd:r(logp)}}log posterior at the new point{p_end}
{p2colreset}{...}


{title:Example}

{pstd}
Update parameter 3 of the row vector b using a grid of 5 points{p_end}
{phang2}
{cmd:. gbsgriddy mylogpost b 3, grid(-2 -1 0 1 2)}{p_end}


{title:Author}

{pstd}
John Thompson{break}
Department of Health Sciences{break}
University of Leicester, UK{break}

{pstd}
Please report any errors to
{browse "mailto:john.thompson@le.ac.uk":john.thompson@le.ac.uk}.
{p_end}
