{smcl}
{* *! version 1.0.0  22Fe2009}{...}
{cmd:help logdensity} 
{hline}

{title:Title}

{p2colset 5 19 21 2}{...}
{p2col :{hi:logdensity} {hline 2}}Log density of a standard distribution{p_end}
{p2colreset}{...}


{title:Syntax}

{phang2}
{cmd:logdensity} {it:distribution logp value par1 par2} ...
{ifin} {weight}

{synoptset 15}{...}
{synopt:Arguments}Description{p_end}
{synoptline}
{synopt:{it:distribution}}name of the distribution as a string; see 
{help logdensity##distribution:below}{p_end}
{synopt:{it:logp}}name of a scalar to which the result is added{p_end}
{synopt:{it:value}}observation that follows the distribution; either a single
value or a variable (if a variable, the sum of the log densities is added to
{it:logp}){p_end}
{synopt:{it:par1}}first parameter of the distribution; either a number or  a variable{p_end}
{synopt:{it:par2}}second parameter if the distribution has one{p_end}
{synoptline}
{p2colreset}{...}

{pstd}
The distributions available with {cmd:logdensity} are listed below. Here
{it:logp} stands for the name of a scalar, {it:y} stands for the value,
and the parameters are then listed in order. Parameter names in uppercase must
be specified as Stata matrices.

{marker distribution}{...}
{synoptset 29}{...}
{synopthdr:distribution}
{synoptline}
{synopt:{opt bernoulli}}{cmd:logdensity bernoulli} {it:logp y p}{p_end}
{synopt:{opt beta}}{cmd:logdensity beta} {it:logp y alpha beta}{p_end}
{synopt:{opt binomial}}{cmd:logdensity binomial} {it:logp y n p}{p_end}
{synopt:{opt categorical}}{cmd:logdensity categorical} {it:logp y p}{p_end}
{synopt:{opt chisqr} (chi-squared)}{cmd:logdensity chisqr} {it:logp y k}{p_end}
{synopt:{opt dirichlet}}{cmd:logdensity dirichlet} {it:logp y alpha}{p_end}
{synopt:{opt exponential}}{cmd:logdensity exponential} {it:logp y mu}{p_end}
{synopt:{opt gamma}}{cmd:logdensity gamma} {it:logp y alpha beta}{p_end}
{synopt:{opt gengamma} (generalized gamma)}{cmd:logdensity gengamma} {it:logp y alpha beta gamma}{p_end}
{synopt:{opt igamma} (inverse gamma)}{cmd:logdensity igamma} {it:logp y alpha beta}{p_end}
{synopt:{opt igauss} (inverse gaussian)}{cmd:logdensity igauss} {it:logp y mu lambda}{p_end}
{synopt:{opt laplace}}{cmd:logdensity laplace} {it:logp y mu b}{p_end}
{synopt:{opt logistic}}{cmd:logdensity logistic} {it:logp y mu b}{p_end}
{synopt:{opt lognormal}}{cmd:logdensity lognormal} {it:logp y mu sigma}{p_end}
{synopt:{opt multinomial}}{cmd:logdensity multinomial} {it:logp y p}{p_end}
{synopt:{opt mnormal} (multivariate normal)}{cmd:logdensity mnormal} {it:logp y mu sigma}{p_end}
{synopt:{opt mt} (multivariate t)}{cmd:logdensity mt} {it:logp y mu sigma k}{p_end}
{synopt:{opt negbin} (negative binomial)}{cmd:logdensity negbin} {it:logp y n p k}{p_end}
{synopt:{opt normal} (Gaussian)}{cmd:logdensity normal} {it:logp y mu sd}{p_end}
{synopt:{opt pareto}}{cmd:logdensity pareto} {it:logp y a c}{p_end}
{synopt:{opt poisson}}{cmd:logdensity poisson} {it:logp y lambda}{p_end}
{synopt:{opt t} (Student's t)}{cmd:logdensity t} {it:logp y mu sigma k}{p_end}
{synopt:{opt uniform}}{cmd:logdensity uniform} {it:logp y a b}{p_end}
{synopt:{opt weibull}}{cmd:logdensity weibull} {it:logp y v mu}{p_end}
{synopt:{opt wishart}}{cmd:logdensity wishart} {it:logp Y sigma k}{p_end}
{synoptline}
{p2colreset}{...}

{p 4 6 2}
For the {cmd:binomial} distribution, the factorial terms are omitted so that
{it:p} is treated as a parameter and {it:n} is treated as fixed.  For the
{cmd:wishart} distribution, {it:k} is treated as fixed.  The
{cmd:multinomial} and {cmd:dirichlet} distributions assume that {it:y}, {it:p},
and {it:alpha} are stored in Stata variables.

{p 4 6 2}
The Mata versions of {cmd:logdensity} are in the library {cmd:libmcmc}
but return the value of the {cmd:logdensity} rather than add it to a scalar.

{p 4 6 2}
{opt fweight}s are allowed; see {help weight}.


{title:Description}

{pstd}
{cmd: logdensity} evaluates the log density of a standard distribution and
adds the result to a user-supplied scalar, {it:logp}. The
program is intended for use in programs for calculating the log posterior;
see {helpb mhsnorm}.  However, for complex models that require many
evaluations of the log posterior, it might be worth replacing the calls to
{cmd:logdensity} with user-written code that can be made more efficient by
omitting unnecessary terms that do not depend on the parameter of
interest.{p_end}


{title:Example}

{phang}{cmd:. scalar lp = 0}{p_end}
{phang}{cmd:. logdensity binomial y 10 0.2}{p_end}


{title:Author}

{pstd}
John Thompson{break}
Department of Health Sciences{break}
University of Leicester, UK{break}

{pstd}
Please report any errors to
{browse "mailto:john.thompson@le.ac.uk":john.thompson@le.ac.uk}.
{p_end}
