{smcl}
{* *! version 1.0.0  dec2012}{...}
{cmd:help mcmccusum} 
{hline}

{title:Title}

{p2colset 5 18 20 2}{...}
{p2col :{hi:mcmccusum} {hline 2}}Cusum plots of an MCMC run{p_end}
{p2colreset}{...}


{title:Syntax}

{phang2}
{cmd:mcmccusum} {varlist} {ifin} [{cmd:,} {it:options}]

{synoptset 20}{...}
{synopthdr}
{synoptline}
{synopt:{opth c:hain(varname)}}variable containing the chain number{p_end}
{synopt:{opt r:eference(#)}}number of reference plots{p_end}
{synopt:{opth i:teration(varname)}}counter for the x axis{p_end}
{synopt:{opt over:lay}}overlay the plots on the same axis{p_end}
{synopt:{opt gopt:ions(string)}}any {helpb twoway_options:twoway} options to
affect the rendition of the individual plots{p_end}
{synopt:{opt cgopt:ions(string)}}any {helpb graph combine} options to affect
the rendition of combining plots{p_end}
{synoptline}
{p2colreset}{...}


{title:Description}

{pstd}
{cmd:mcmccusum} plots the cumulative sum of deviations about the mean, or the
cusum. Useful for detecting early drift in the chain caused by the choice of
initial values. If more than one variable is specified, then the separate plots
will be combined and placed next to one another.


{title:Options}

{phang}
{opth chain(varname)} specifies the name of a variable containing the chain
number for multichain MCMC runs. If this variable is specified, the cusums of
the chains will be superimposed on the same plot. 

{phang}
{opt reference(#)} specifies the number of reference plots, that is, the
cusums from series with the same mean, standard deviation, and autocorrelation
as the actual data, but no drift.

{phang}
{opth iteration(varname)} specifies the variable containing the order of the
chain for use as the x axis. If {cmd:iteration()} is not specified, then the
data are plotted in the order in which they appear in the file at points 1, 2,
3, ....

{phang}
{opt overlay} plots different chains on the same set of axes.

{phang}
{opt goptions(string)} are any of the {helpb twoway_options:twoway} options
for controlling the plots of each set of cusums. 

{phang}
{opt cgoptons(string)} are any of the {helpb graph combine} options to control
the combining of the plots. 


{title:Example}

{phang}
{cmd:. mcmccusum x y, reference(3) cgoptions(row(2))}{p_end}


{title:Author}

{pstd}
John Thompson{break}
Department of Health Sciences{break}
University of Leicester, UK{break}

{pstd}
Please report any errors to
{browse "mailto:john.thompson@le.ac.uk":john.thompson@le.ac.uk}.
{p_end}
