{smcl}
{* *! version 1.0.0  dec2012}{...}
{cmd:help mcmcdensity} 
{hline}

{title:Title}

{p2colset 5 20 22 2}{...}
{p2col :{hi:mcmcdensity} {hline 2}}Smoothed density estimates of the posterior from an MCMC run
{p2colreset}{...}


{title:Syntax}

{phang2}
{cmd:mcmcdensity}
{varlist} 
{ifin}
[{cmd:,} {it:options}]

{synoptset 24}{...}
{synopthdr}
{synoptline}
{synopt:{opt l:bounds(string)}}lower bounds for each parameter{p_end}
{synopt:{opt u:bounds(string)}}higher bounds for each parameter{p_end}
{synopt:{opt kopt:ions(string)}}options passed directly to {helpb kdensity}{p_end}
{synopt:{opt gopt:ions(string)}}any {helpb twoway_options:twoway} options to
affect rendition of the individual plots{p_end}
{synopt:{opt cgopt:ions(string)}}any {helpb graph combine} options to affect
rendition of combining plots{p_end}
{synopt:{cmdab:s:ave(}{it:string}{cmd:, replace)}}{cmd:.dta} file for saving the plotting points{p_end}
{synopt:{opt add:plot(string)}}add other plots to the generated graph{p_end}
{synoptline}
{p2colreset}{...}


{title:Description}

{pstd}
{cmd:mcmcdensity} plots the smoothed density estimate from an MCMC chain. This
command is a wrapper that calls the Stata command {helpb kdensity}.
However, it will allow bounds to be set. For example, because the posterior of
a standard deviation is known to be positive, it is possible to get a smooth
density that does not allocate probability to negative values by setting
{cmd:lbounds(0)} and {cmd:ubound(.)}. The boundary is imposed by reflecting
the data in the limit as described in
{help mcmcdensity##S1986:Silverman (1986, 30)}.


{title:Options}

{phang}
{opt lbounds(string)} specifies the lower bound for each parameter. There may
be a list of lower values, one for each parameter in {it:varlist}. A missing
value means no lower bound. If {cmd:lbounds()} is not specified, then no lower
boundaries are set.

{phang}
{opt ubounds(string)} specifies the upper bound for each parameter. A missing
value means no upper bound. If {cmd:ubounds()} is not specified, then no upper
boundaries are set.

{phang}
{opt koptions(string)} specifies the options passed directly to
{helpb kdensity}. 

{phang}
{opt goptions(string)} are any of the {helpb twoway_options:twoway} options
for controlling the plot of each density. 

{phang}
{opt cgoptions(string)} are any of the {helpb graph combine} options to
control the combining of the plots. 

{phang}
{cmd:save(}{it:string}{cmd:, replace)} specifies the Stata data file
({cmd:.dta}) for saving the coordinates for each plot.

{phang}
{opt addplot(string)} provides a way to add other plots to the generated
graph.  See {manhelpi addplot_option G-3}.


{title:Example}

{phang}
{cmd:. mcmcdensity alpha beta, lbound(0 .) ubound(1 .)}{p_end}


{title:Reference}

{marker S1986}{...}
{phang}
Silverman, B. W. 1986.
{it:Density Estimation for Statistics and Data Analysis}.
Boca Raton, FL: Chapman & Hall/CRC.


{title:Author}

{pstd}
John Thompson{break}
Department of Health Sciences{break}
University of Leicester, UK{break}

{pstd}
Please report any errors to
{browse "mailto:john.thompson@le.ac.uk":john.thompson@le.ac.uk}.
{p_end}
