{smcl}
{* *! version 1.0.0  dec2012}{...}
{cmd:help mcmcintervals} 
{hline}

{title:Title}

{p2colset 5 22 24 2}{...}
{p2col :{hi:mcmcintervals} {hline 2}}Interval plots for sections of a chain{p_end}
{p2colreset}{...}


{title:Syntax}

{phang2}
{cmd:mcmcintervals}
{varlist} 
{ifin}
[{cmd:,} {it:options}]

{synoptset 22}{...}
{synopthdr}
{synoptline}
{synopt:{opt m:(#)}}number of sections within each chain{p_end}
{synopt:{opt l:evel(#)}}percentage covered by the interval{p_end}
{synopt:{opth c:hain(varname)}}separate interval for each chain{p_end}
{synopt:{opth i:teration(varname)}}counter for the x axis{p_end}
{synopt:{opt gopt:ions(string)}}any {helpb twoway_options:twoway} options to
affect rendition of the individual plots{p_end}
{synopt:{opt cgopt:ions(string)}}any {helpb graph combine} options to affect
rendition of combining plots{p_end}
{synopt:{cmdab:s:ave(}{it:string}{cmd:, replace)}}{cmd:.dta} file for saving the plotting points{p_end}
{synoptline}
{p2colreset}{...}


{title:Description}

{pstd}
{cmd:mcmcintervals} plots interval estimates for {cmd:m()} consecutive
sections of the chain. Intervals are calculated from the appropriate centiles
of that portion of the chain.  If {varlist} contains more than one parameter,
the separate plots are combined. The {cmd:chain()} option plots the intervals
for multiple parallel chains and superimposes them on the same plot. A
horizontal dashed line shows the overall median.


{title:Options}

{phang}
{opt m(#)} specifies the number of sections into which the chain is divided.
The default is {cmd:m(10)}.

{phang}
{opt level(#)} specifies the percentage within the plotted interval.
The default is {cmd:level(80)}.

{phang}
{opth chain(varname)} specifies the chain identifier and requests that separate
intervals for each chain be superimposed on a single plot.

{phang}
{opth iteration(varname)} specifies the variable containing the order of the
chain for use as the x axis. If {cmd:iteration()} not specified, then the data
are plotted in the order in which they appear in the file at points 1, 2, 3,
....

{phang}
{opt goptions(string)} are any of the {helpb twoway_options:twoway} options
for controlling the plots of the intervals. 

{phang}
{opt cgoptions(string)} are any of the {helpb graph combine} options to
control the combining of the plots. 

{phang}
{cmd:save(}{it:string}{cmd:, replace)} specifies the Stata data file
({cmd:.dta}) for saving the plotting points.


{title:Example}

{phang}{cmd:. mcmcintervals alpha beta, level(50)}{p_end}


{title:Author}

{pstd}
John Thompson{break}
Department of Health Sciences{break}
University of Leicester, UK{break}

{pstd}
Please report any errors to
{browse "mailto:john.thompson@le.ac.uk":john.thompson@le.ac.uk}.
{p_end}
