{smcl}
{* *! version 1.0.0  dec2012}{...}
{cmd:help mcmcsection} 
{hline}

{title:Title}

{p2colset 5 20 22 2}{...}
{p2col :{hi:mcmcsection} {hline 2}}Density plots of sections of a chain{p_end}
{p2colreset}{...}


{title:Syntax}

{phang2}
{cmd:mcmcsection}
{varlist} 
{ifin}
[{cmd:,} {it:options}]

{synoptset 24}{...}
{synopthdr}
{synoptline}
{synopt:{opt m(#)}}number of sections within each chain{p_end}
{synopt:{opth c:hain(varname)}}plot by chain rather than by section{p_end}
{synopt:{opt kopt:ions(string)}}options passed directly to {helpb kdensity}{p_end}
{synopt:{opt gopt:ions(string)}}any {helpb twoway_options:twoway} options to
affect rendition of the individual plots{p_end}
{synopt:{opt cgopt:ions(string)}}any {helpb graph combine} options to affect
rendition of combining plots{p_end}
{synopt:{cmdab:s:ave(}{it:string}{cmd:, replace)}}{cmd:.dta} file for saving the plotting positions{p_end}
{synopt:{opt nod}}suppresses the measure of the difference, D{p_end}
{synoptline}
{p2colreset}{...}


{title:Description}

{pstd}
{cmd:mcmcsection} plots smoothed density estimates for the whole MCMC chain
(solid line) and for {opt m(#)} fractions of the chain (dashed lines). For
instance, {cmd:m(3)} plots three smoothed densities for the first, middle, and
last third of the chain. Densities are smoothed using {helpb kdensity}.  The
measure D represents the maximum difference of two sectional densities as a
percentage of the maximum height of the density of the whole chain. D < 20
usually looks like reasonable agreement; D < 10 is good. If {varlist} contains
more than one parameter, the separate plots are created and then combined. 


{title:Options}

{phang}
{opt m(#)} specifies the number of sections into which the chain is divided.
The default is {cmd:m(2)}.

{phang}
{opth chain(varname)} specifies the chain identifier and requests superimposed
densities for each chain rather than sections of one chain. If this option is
specified, the {opt m()} option is ignored.

{phang}
{opt koptions(string)} specifies the options passed directly to
{helpb kdensity}. 

{phang}
{opt goptions(string)} specifies the {helpb twoway_options:twoway} options for
controlling the density plots. 

{phang}
{opt cgoptions(string)} specifies the {helpb graph combine} options to control
the combining of the plots. 

{phang}
{cmd:save(}{it:string}{cmd:, replace)} specifies the Stata data file
({cmd:.dta}) for saving the plotting positions.

{phang}
{opt nod} omits the measure of the difference, D.


{title:Example}

{phang}{cmd:. mcmcsection alpha, m(3) goptions(scheme(s1mono))}{p_end}


{title:Author}

{pstd}
John Thompson{break}
Department of Health Sciences{break}
University of Leicester, UK{break}

{pstd}
Please report any errors to
{browse "mailto:john.thompson@le.ac.uk":john.thompson@le.ac.uk}.
{p_end}
