{smcl}
{* *! version 1.0.0  dec2012}{...}
{cmd:help mcmcstats} 
{hline}

{title:Title}

{p2colset 5 18 20 2}{...}
{p2col :{hi:mcmcstats} {hline 2}}Summary statistics for an MCMC run{p_end}
{p2colreset}{...}


{title:Syntax}

{phang2}
{cmd:mcmcstats}
{varlist} 
{ifin}
[{cmd:,} {it:options}]

{synoptset 24}{...}
{synopthdr}
{synoptline}
{synopt:{opt h:pd}}highest posterior density intervals{p_end}
{synopt:{opt l:evel(#)}}percentage for the interval estimates{p_end}
{synopt:{opt cor:relations}}print correlation matrix{p_end}
{synopt:{opt cov:ariances}}print covariance matrix{p_end}
{synopt:{cmdab:s:ave(}{it:string}{cmd:, replace)}}{cmd:.dta} file for saving the summary statistics{p_end}
{synoptline}
{p2colreset}{...}
{p 4 6 2}{helpb by} may be used with {cmd:mcmcstats}.


{title:Description}

{pstd}
{cmd:mcmcstats} writes a table summarizing the MCMC results for {varlist},
including the number of observations, mean, standard deviation, standard
error, median, and credible interval. The standard error is calculated using
{helpb prais} regression.  {cmd:mcmcstats} is byable and returns the
calculated summary statistics.


{title:Options}

{phang}
{opt hpd} specifies the highest posterior density intervals rather than
credible intervals.  The highest posterior density is difficult to estimate
from very small datasets, and if the algorithm cannot locate the highest
posterior density accurately, the limits are set to missing. 

{phang}
{opt level(#)} specifies the percentage level for the interval estimates.
The default is {cmd:level(95)}.

{phang}
{opt correlations} prints and returns the correlation matrix for the
parameters.

{phang}
{opt covariances} prints and returns the covariance matrix for the parameters.

{phang}
{cmd:save(}{it:string}{cmd:, replace)} specifies the Stata data file
({cmd:.dta}) for saving the summary statistics.


{title:Examples}

{phang}{cmd:. mcmcstats x y z}{p_end}
{phang}{cmd:. by chain, sort: mcmcstats x y z}


{title:Stored results}

{pstd}
For the first parameter in {varlist}, {cmd:mcmcstats} stores the following
scalars:{p_end}

{synoptset 15 tabbed}{...}
{synopt:{cmd:r(par1)}}parameter name{p_end}
{synopt:{cmd:r(n1)}}number of simulations{p_end}
{synopt:{cmd:r(mn1)}}mean{p_end}
{synopt:{cmd:r(sd1)}}standard deviation{p_end}
{synopt:{cmd:r(se1)}}standard error{p_end}
{synopt:{cmd:r(md1)}}median{p_end}
{synopt:{cmd:r(lb1)}}interval lower bound{p_end}
{synopt:{cmd:r(ub1)}}interval upper bound{p_end}
{p2colreset}{...}

{pstd}
Other parameters have their summary statistics returned as {cmd:r(n2)},
{cmd:r(n3)}, etc. The correlation matrix is returned as {cmd:r(C)},
and the covariance matrix is returned as {cmd:r(V)}.{p_end}


{title:Author}

{pstd}
John Thompson{break}
Department of Health Sciences{break}
University of Leicester, UK

{pstd}
Please report any errors to
{browse "mailto:john.thompson@le.ac.uk":john.thompson@le.ac.uk}.
{p_end}
