*! 1.0.0, John Thompson, 1 Jan 2014
program wbsarray
   version 8.2
   syntax varlist [using/] [if] [in] , ///
   [ Formats(string) ///
   Names(string) ///
   REPLACE ]
   
   marksample touse , novarlist
   
   local nvar : word count `varlist'
   * -------------------------------
   * construct the format
   * -------------------------------
   if "`formats'" == "" {
      local f1 = "%8.3f"
      local sf1 = "%8s"
      local nf = 1
   }
   else {
      tokenize "`formats'"
      local nf = 1
      while "``nf''" != "" {
         local f`nf' = "``nf''"
         local np = index("``nf''" , ".")
         local sp = substr("``nf''" , 2 , `np'-2)
         local sf`nf' = "%`sp's"
         local nf = `nf' + 1
      }
      local nf = `nf' - 1
   }
   local n = _N
   * -------------------------------
   * variable names
   * -------------------------------
   if "`names'" == "" {
      local k = 1
      foreach x of varlist `varlist' {
         local name`k' "`x'[]"
         local k = `k' + 1
      }
   }
   else {
      tokenize "`names'"
      local k = 1
      while "``k''" != "" {
         local name`k' "``k''"
         if( strpos("`name`k''","[") == 0 ) {
            local name`k' "`name`k''[]"
         }
         local k = `k' + 1
      }
      local --k
      if `k' ! = `nvar' {
         di as err "Wrong number of names"
         exit
      }
   }
   * -------------------------------
   * data header
   * -------------------------------
   local k = 1
   local p = 1
   foreach x of varlist `varlist' {
      di as res `sf`k'' " `name`p''" _continue
      local k = `k' + 1
      local p = `p' + 1
      if `k' > `nf' {
         local k = 1
      }
   }
   di " "
   * -------------------------------
   * data .. line by line
   * -------------------------------
   forvalues i = 1 / `n' {
      if `touse'[`i'] == 1 {
         local k = 1
         foreach x of varlist `varlist' {
            local y = `x'[`i']
            if `y' == . {
               di as res `sf`k'' "NA" _continue
            }
            else {
               di as res `f`k'' `y' _continue
            }
            local k = `k' + 1
            if `k' > `nf' {
               local k = 1
            }
         }
         di " "
      }
   }
   di as res "END"
   * -------------------------------
   * if required write to file
   * -------------------------------
   if `"`using'"' != "" {
      tempname WB
      file open `WB' using `"`using'"' , write `replace'
      local k = 1
      local p = 1
      foreach x of varlist `varlist' {
         file write `WB' `sf`k'' (" `name`p''")
         local k = `k' + 1
         local p = `p' + 1
         if `k' > `nf' {
            local k = 1
         }
      }
      file write `WB' _n
      
      forvalues i = 1 / `n' {
         if `touse'[`i'] == 1 {
            local k = 1
            foreach x of varlist `varlist' {
               local y = `x'[`i']
               if `y' == . {
                  file write `WB' `sf`k'' ("NA")
               }
               else {
                  file write `WB' `f`k'' (`y')
               }
               local k = `k' + 1
               if `k' > `nf' {
                  local k = 1
               }
            }
            file write `WB' _n
         }
      }
      file write `WB' "END" _n
      file close `WB'
   }
end
