{smcl}
{* *! version 1.0.0  22May2006}{...}
{cmd:help wbsdecode} 
{hline}

{title:Title}

{p2colset 5 18 20 2}{...}
{p2col :{hi:wbsdecode} {hline 2}}Read data stored as WinBUGS structures into Stata{p_end}
{p2colreset}{...}


{title:Syntax}

{phang2}
{cmd:wbsdecode} {cmd:using} {it:{help filename}}{cmd:,}
{opt clear}
[{cmdab:a:rray}]

{synoptset 12 tabbed}{...}
{synopthdr}
{synoptline}
{p2coldent:* {opt clear}}clears data from memory{p_end}
{synopt:{opt a:rray}}read a WinBUGS array rather than a list{p_end}
{synoptline}
{p2colreset}{...}
{p 4 6 2}
* {cmd:clear} is required.


{title:Description}

{pstd}
{cmd:wbsdecode} reads data from a text file when the data are stored in
WinBUGS format, that is, as a list or an array. If the data are part
of a compound document, they must be copied to a text file before using
{cmd:wbsdecode}. {cmd:wbsdecode} is useful for reading the data from the
examples supplied with WinBUGS so that the data can be processed in Stata;
it also reads data from R or S-plus structures.  Any data currently
in Stata will be lost, so you must specify the {cmd:clear} option.


{title:Options}

{phang}
{opt clear} clears the data from memory.  {cmd:clear} is required.

{phang}
{opt array} specifies to read an array instead of a list.


{title:Example}

{phang}{cmd:. wbsdecode using text.txt, clear}{p_end}


{title:Warning}

{pstd}
{cmd:wbsdecode} reads lists by searching for the next "=" and then
locating the variable name that precedes it and the structure type that
follows it. Spreading this information over more than one line would cause
{cmd:wbsdecode} to misread the data. So typing{p_end}

{col 10}y = c(
{col 10}1 ,2 ,3)

{pstd} would work, but typing{p_end}

{col 10}y
{col 10}= c(1, 2, 3)

{pstd} would fail.{p_end}


{title:Additional software}

{pstd}
The WinBUGS Manual is available from {browse www.mrc-bsu.cam.ac.uk/bugs}.
Information about OpenBUGS is available from {browse www.openbugs.net/}.
See {search winbugs} for a list of all the commands for running WinBUGS from
Stata.


{title:Author}

{pstd}
John Thompson{break}
Department of Health Sciences{break}
University of Leicester, UK{break}

{pstd}
Please report any errors to
{browse "mailto:john.thompson@le.ac.uk":john.thompson@le.ac.uk}.
{p_end}
