{smcl}
{* *! version 1.0.0  22May2006}{...}
{cmd:help wbsscript} 
{hline}

{title:Title}

{p2colset 5 18 20 2}{...}
{p2col :{hi:wbsscript} {hline 2}}Write a WinBUGS script file{p_end}
{p2colreset}{...}


{title:Syntax}

{phang2}
{cmd:wbsscript} [{cmd:using} {it:{help filename}}]{cmd:,}
{opt m:odelfile(string)} [{it:options}]

{synoptset 20 tabbed}{...}
{synopthdr}
{synoptline}
{p2coldent:* {opt m:odelfile(string)}}file containing the model{p_end}
{synopt:{opt p:ath(string)}}path placed before all filenames{p_end}
{synopt:{opt d:atafile(string)}}files of data{p_end}
{synopt:{opt i:nitsfile(string)}}files of initial values{p_end}
{synopt:{opt s:et(string)}}parameters to save{p_end}
{synopt:{opt b:urnin(#)}}length of the burn-in{p_end}
{synopt:{opt u:pdates(#)}}length of each chain{p_end}
{synopt:{opt t:hin(#)}}save every {it:#}th simulation{p_end}
{synopt:{opt c:odafile(string)}}root of file for saving MCMC values{p_end}
{synopt:{opt dic:}}write deviance information criterion to the log{p_end}
{synopt:{opt l:ogfile(string)}}text file for saving the log{p_end}
{synopt:{opt noq:uit}}do not close WinBUGS on completion{p_end}
{synopt:{opt o:penbugs}}use OpenBUGS scripting language{p_end}
{synopt:{opt replace:}}replace script file if it exists{p_end}
{synoptline}
{p2colreset}{...}
{p 4 6 2}
* {cmd:modelfile()} is required.


{title:Description}

{pstd}
{cmd:wbsscript} writes a WinBUGS script file (or optionally an OpenBUGS script
file) for fitting a model.  The script files are not interchangeable because
WinBUGS and OpenBUGS use different scripting languages.


{title:Options}

{phang}
{opt modelfile(string)} specifies the name of the file containing the model
description. {cmd:modelfile()} is required.

{phang}
{opt path(string)} specifies the path of {it:string} in {cmd:datafile()},
{cmd:initsfile()}, {cmd:modelfile()}, {cmd:codafile()}, and {cmd:logfile()}.
This saves typing the same path for every file when files are stored together
in the same folder. It is important to give full path names for every file
because when WinBUGS runs, you cannot assume that it will start in the same
working directory that you are using in Stata. Hence, you should either type
full paths for each filename or specify the common path with this option.  If
the files are in Stata's current working directory, then this can be specified
using {cmd:path("`c(pwd)'")}.

{phang}
{opt datafile(string)} name of the data file. Multiple data files should
be separated by {cmd:+}'s as in{p_end}

{phang2}{cmd:datafile(data1.txt+data2.txt)}

{phang}
{opt initsfile(string)} specifies the names of the files containing the
initial values.  The names of the initial-value files should be separated by
{cmd:+}'s as with data files, for instance,{p_end}

{phang2}{cmd:initsfile(in1.txt+int2.txt+int3.txt)}

{pmore}
When multiple initial-value files are specified, a separate chain is run for
each set of initial values.  A {cmd:gen.inits} command automatically follows
the reading of initial values so that WinBUGS will try to randomly generate
initial values for any parameters not explicitly mentioned in the "inits"
files.  WinBUGS is not always able to generate initial values, and in rare
circumstances, this can cause a program to fail.

{phang}
{opt set(string)} specifies the list of the parameters that need to have their
MCMC values saved.

{phang}
{opt burnin(#)} specifies the length of the burn-in. 
The default is {cmd:burnin(0)}, meaning no burn-in.

{phang}
{opt updates(#)} specifies the length of the actual chain. 
The default is {cmd:updates(1000)}.

{phang}
{opt thin(#)} save every {it:#}th simulation. The default
is {cmd:thin(1)}, meaning no thinning and save all simulations.

{phang}
{opt codafile(string)} specifies the root for the name of the files for saving
the MCMC results in coda format.  Do not insert a file extension (for example,
{cmd:.txt}) on the name, because WinBUGS creates several coda files with this
specified root, an index file and a data file for each chain. The extension is
added by WinBUGS.

{phang}
{opt dic} specifies that the deviance information criterion be calculated and
written to the log file.

{phang}
{opt logfile(string)} specifies the name for the log file that will contain a
progress report, error messages, timings, and, if requested, the
deviance information criterion. 

{phang}
{opt noquit} specifies that WinBUGS should stay active when the run
is complete. The default is to quit WinBUGS after the analysis and return
control immediately to Stata.  {cmd:noquit} is intended for debugging the
model file. 

{phang}
{opt openbugs} specifies to use the OpenBUGS scripting language.{p_end}

{phang}
{opt replace} specifies that the script file be overwritten if it already
exists.{p_end}


{title:Example}

{phang}{cmd:. wbsscript using script.txt, model(model.txt)}{break}
       {cmd:data(data1.txt+data2.txt) path(d:/tutorial)}{break}
       {cmd:inits(init.txt) coda(out) set(alpha beta)}{break}
       {cmd:burn(1000) update(5000) replace}{p_end}


{title:Additional software}

{pstd}
The WinBUGS Manual is available from {browse www.mrc-bsu.cam.ac.uk/bugs}.
Information about OpenBUGS is available from {browse www.openbugs.net/}.
See {search winbugs} for a list of all the commands for running WinBUGS from
Stata.


{title:Author}

{pstd}
John Thompson{break}
Department of Health Sciences{break}
University of Leicester, UK{break}

{pstd}
Please report any errors to
{browse "mailto:john.thompson@le.ac.uk":john.thompson@le.ac.uk}.
{p_end}
